VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7110
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9420
   LinkTopic       =   "Form1"
   ScaleHeight     =   7110
   ScaleWidth      =   9420
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   525
      Left            =   7980
      TabIndex        =   1
      Top             =   90
      Width           =   1425
   End
   Begin VB.TextBox Text1 
      Height          =   6975
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   60
      Width           =   7875
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim a_File() As Byte
Dim i_CurrentByte As Integer

Private Sub cmdSave_Click()

    'On Local Error Resume Next

    Dim b_Byte As Byte
    
    i_CurrentByte = 0
    
    a_Code = Split(Text1.Text, vbCrLf)
    
    For i = 0 To UBound(a_Code)
    
        If Left(a_Code(i), 1) = "[" And Right(a_Code(i), 1) = "]" Then
            
            PutByte 1
            
            s_Label = LCase(Mid(a_Code(i), 2, Len(a_Code(i)) - 2))
            Select Case s_Label
            Case "header"
                PutByte 1
            Case "normal"
                PutByte 2
            Case "combo"
                PutByte 3
            Case "chain"
                PutByte 4
            Case "bigchain"
                PutByte 5
            Case "die"
                PutByte 6
            Case Else
                MsgBox "Unrecognized label "" & s_Label & "" on line " & i + 1
                ClearFile
                Exit Sub
            End Select
        
        Else
        
            If a_Code(i) <> "" Then
                a_Cmd = Split(a_Code(i), " ")
        
                Select Case LCase(a_Cmd(0))
                Case "setrect"
                    
                    If UBound(a_Cmd) <> 5 Then
                        MsgBox "Function SetRect requires 5 parameters. Line: " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                    
                    PutByte 2
                    
                    For j = 1 To UBound(a_Cmd)
                        a_Cmd(j) = Replace(a_Cmd(j), ",", "")
                        PutByte a_Cmd(j)
                    Next j
                    
                Case "bigchain"
                
                    If UBound(a_Cmd) <> 1 Then
                        MsgBox "Function BigChain requires 1 parameter. Line: " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                    
                    PutByte 3
                    PutByte a_Cmd(1)
                    
                Case "frame"
                
                    If UBound(a_Cmd) <> 2 Then
                        MsgBox "Missing parameter or { on line " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                        
                    For j = i To UBound(a_Code)
                        If a_Code(j) = "}" Then
                            i_End = j
                            Exit For
                        End If
                    Next j
                
                    If i_End = 0 Then
                        MsgBox "{ without } on line " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                
                    PutByte 4
                    PutByte a_Cmd(1)
                    PutByte (i_End - i - 1)
                
                Case "move"
                
                    If UBound(a_Cmd) <> 5 Then
                        MsgBox "Move requires five parameters. Line: " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                    
                    PutByte 5
                    For j = 1 To UBound(a_Cmd)
                        a_Cmd(j) = Replace(a_Cmd(j), ",", "")
                        PutByte a_Cmd(j)
                    Next j
                
                Case "rotate"
                
                    If UBound(a_Cmd) <> 5 Then
                        MsgBox "Rotate requires five parameters. Line: " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                    
                    PutByte 6
                    For j = 1 To UBound(a_Cmd)
                        a_Cmd(j) = Replace(a_Cmd(j), ",", "")
                        PutByte a_Cmd(j)
                    Next j
                
                Case "drawrect"
                
                    If UBound(a_Cmd) <> 1 Then
                        MsgBox "DrawRect requires one parameter. Line: " & i + 1
                        ClearFile
                        Exit Sub
                    End If
                    
                    PutByte 8
                    PutByte a_Cmd(1)
                
                End Select
            
            End If
            
        End If
    
    Next i

    Open "C:\char.chr" For Binary As #1
    Put #1, , a_File
    Close #1

End Sub

Public Sub PutByte(ByVal i_Byte As Integer)

    ReDim Preserve a_File(i_CurrentByte)
    
    If i_Byte >= 255 Then
    
        Do Until i_Byte < 255
            a_File(i_CurrentByte) = 255
            i_Byte = i_Byte - 255
            i_CurrentByte = i_CurrentByte + 1
            ReDim Preserve a_File(i_CurrentByte)
        Loop
        
        a_File(i_CurrentByte) = CByte(i_Byte)
        i_CurrentByte = i_CurrentByte + 1
        
    Else
        a_File(i_CurrentByte) = CByte(i_Byte)
        i_CurrentByte = i_CurrentByte + 1
    End If

End Sub

Public Sub ClearFile()

    ReDim a_File(0)
    i_CurrentByte = 0

End Sub
